import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'flt_starter_method_channel.dart';

abstract class FltStarterPlatform extends PlatformInterface {
  /// Constructs a FltStarterPlatform.
  FltStarterPlatform() : super(token: _token);

  static final Object _token = Object();

  static FltStarterPlatform _instance = MethodChannelFltStarter();

  /// The default instance of [FltStarterPlatform] to use.
  ///
  /// Defaults to [MethodChannelFltStarter].
  static FltStarterPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [FltStarterPlatform] when
  /// they register themselves.
  static set instance(FltStarterPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }
}
